/* Definitions for A-812PG.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.0.0  2 May 2003 by Reed Lai
     Bark! Bark! */

#ifndef _A812PG_H
#define _A812PG_H

#define MODULE_NAME        "ixa812pg"
#define IO_RANGE           0x10
#define DMA_TRANSFER_MODE  0x02	/* value for ADMCR */

/* offset of registers */
#define _8254_COUNTER_0                  0x00
#define _8254_COUNTER_1                  0x01
#define _8254_COUNTER_2                  0x02
#define _8254_CONTROL_WORD_REG           0x03
#define ANALOG_INPUT_L                   0x04
#define ANALOG_INPUT_H                   0x05
#define ANALOG_OUTPUT_0_L                0x04
#define ANALOG_OUTPUT_0_H                0x05
#define ANALOG_OUTPUT_1_L                0x06
#define ANALOG_OUTPUT_1_H                0x07
#define DIGITAL_INPUT_L                  0x06
#define DIGITAL_INPUT_H                  0x07
#define CLEAR_INTERRUPT_REQUEST          0x08
#define AD_GAIN_CONTROL_REG              0x09
#define AD_MULTIPLEX_CONTROL_REG         0x0a
#define AD_MODE_CONTROL_REG              0x0b
#define AD_SOFTWARE_TRIGGER_CONTROL_REG  0x0c
#define DIGITAL_OUTPUT_L                 0x0d
#define DIGITAL_OUTPUT_H                 0x0e
#define RESERVED_REG                     0x0f

#define _8254C0   _8254_COUNTER_0
#define _8254C1   _8254_COUNTER_1
#define _8254C2   _8254_COUNTER_2
#define _8254CR   _8254_CONTROL_WORD_REG
#define AIL       ANALOG_INPUT_L
#define AIH       ANALOG_INPUT_H
#define AOL       ANALOG_OUTPUT_0_L
#define AOH       ANALOG_OUTPUT_0_H
#define AO0L      ANALOG_OUTPUT_0_L
#define AO0H      ANALOG_OUTPUT_0_H
#define AO1L      ANALOG_OUTPUT_1_L
#define AO1H      ANALOG_OUTPUT_1_H
#define DIL       DIGITAL_INPUT_L
#define DIH       DIGITAL_INPUT_H
#define CIR       CLEAR_INTERRUPT_REQUEST
#define ADGCR     AD_GAIN_CONTROL_REG
#define ADMXCR    AD_MULTIPLEX_CONTROL_REG
#define ADMCR     AD_MODE_CONTROL_REG
#define ADSTCR    AD_SOFTWARE_TRIGGER_CONTROL_REG
#define DOL       DIGITAL_OUTPUT_L
#define DOH       DIGITAL_OUTPUT_H

/* mask of registers */
#define _8254C0_MASK   0xff
#define _8254C1_MASK   0xff
#define _8254C2_MASK   0xff
#define _8254CR_MASK   0xff
#define AIL_MASK       0xff
#define AIH_MASK       0xff

#define AI_READY_BIT   0x10

#define AOL_MASK       0xff
#define AOH_MASK       0xff
#define AO0L_MASK      0xff
#define AO0H_MASK      0xff
#define AO1L_MASK      0xff
#define AO1H_MASK      0xff
#define DIL_MASK       0xff
#define DIH_MASK       0xff
#define CIR_MASK       0xff
#define ADGCR_MASK     0xff
#define ADMXCR_MASK    0xff
#define ADMCR_MASK     0xff
#define ADSTCR_MASK    0xff
#define DOL_MASK       0xff
#define DOH_MASK       0xff

int write_reg(ixisa_reg_t * reg, unsigned long int base);

#endif							/* _A812PG_H */
