/* Definitions for DIO-96.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.1.0 16 Jan 2002 by Reed Lai
     Create. */

#ifndef _DIO96_H
#define _DIO96_H

#define MODULE_NAME "ixdio96"

#define IO_RANGE       0x10

/* offset of registers */
#define _8255_0_PORT_A          0x0
#define _8255_0_PORT_B          0x1
#define _8255_0_PORT_C          0x2
#define _8255_0_CONTROL_WORD    0x3
#define CN0_PORT_A           _8255_0_PORT_A
#define CN0_PORT_B           _8255_0_PORT_B
#define CN0_PORT_C           _8255_0_PORT_C
#define CN0_CONFIGURED_WORD  _8255_0_CONTROL_WORD
#define CN0PA  CN0_PORT_A
#define CN0PB  CN0_PORT_B
#define CN0PC  CN0_PORT_C
#define CN0CR  CN0_CONFIGURED_WORD

#define _8255_1_PORT_A          0x4
#define _8255_1_PORT_B          0x5
#define _8255_1_PORT_C          0x6
#define _8255_1_CONTROL_WORD    0x7
#define CN1_PORT_A           _8255_1_PORT_A
#define CN1_PORT_B           _8255_1_PORT_B
#define CN1_PORT_C           _8255_1_PORT_C
#define CN1_CONFIGURED_WORD  _8255_1_CONTROL_WORD
#define CN1PA  CN1_PORT_A
#define CN1PB  CN1_PORT_B
#define CN1PC  CN1_PORT_C
#define CN1CR  CN1_CONFIGURED_WORD

#define _8255_2_PORT_A          0x8
#define _8255_2_PORT_B          0x9
#define _8255_2_PORT_C          0xa
#define _8255_2_CONTROL_WORD    0xb
#define CN2_PORT_A           _8255_2_PORT_A
#define CN2_PORT_B           _8255_2_PORT_B
#define CN2_PORT_C           _8255_2_PORT_C
#define CN2_CONFIGURED_WORD  _8255_2_CONTROL_WORD
#define CN2PA  CN2_PORT_A
#define CN2PB  CN2_PORT_B
#define CN2PC  CN2_PORT_C
#define CN2CR  CN2_CONFIGURED_WORD

#define _8255_3_PORT_A          0xc
#define _8255_3_PORT_B          0xd
#define _8255_3_PORT_C          0xe
#define _8255_3_CONTROL_WORD    0xf
#define CN3_PORT_A           _8255_3_PORT_A
#define CN3_PORT_B           _8255_3_PORT_B
#define CN3_PORT_C           _8255_3_PORT_C
#define CN3_CONFIGURED_WORD  _8255_3_CONTROL_WORD
#define CN3PA  CN3_PORT_A
#define CN3PB  CN3_PORT_B
#define CN3PC  CN3_PORT_C
#define CN3CR  CN3_CONFIGURED_WORD

/* mask of registers */
#define CN0PA_MASK    0xff
#define CN0PB_MASK    0xff
#define CN0PC_MASK    0xff
#define CN0CR_MASK    0x9b

#define CN1PA_MASK    0xff
#define CN1PB_MASK    0xff
#define CN1PC_MASK    0xff
#define CN1CR_MASK    0x9b

#define CN2PA_MASK    0xff
#define CN2PB_MASK    0xff
#define CN2PC_MASK    0xff
#define CN2CR_MASK    0x9b

#define CN3PA_MASK    0xff
#define CN3PB_MASK    0xff
#define CN3PC_MASK    0xff
#define CN3CR_MASK    0x9b

#endif							/* _DIO96_H */
