/* Definitions for ENCODER-300.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.0.0  2 May 2003 by Reed Lai
     Bark! Bark! */

#ifndef _ENC300_H
#define _ENC300_H

#define MODULE_NAME        "ixenc300"
#define IO_RANGE           0x10

/* offset of registers */
#define CTRL1            0x00	//write 
#define CTRL2	         0x01	//write
#define CTRL3            0x02	//write
#define VALUE1           0x00	//read
#define VALUE2		 0x01	//read
#define VALUE3		 0x02	//read
#define INDEX		 0x03	//read

/* mask of registers */
#define CTRL1_MASK       0x3f
#define CTRL2_MASK       0x3f
#define CTRL3_MASK       0x3f
#define VALUE1_MASK      0x3f
#define VALUE2_MASK	 0x3f
#define VALUE3_MASK	 0x3f
#define INDEX_MASK	 0x07

int write_reg(ixisa_reg_t * reg, unsigned long int base);

#endif							/* _ENC300_H */
